﻿
namespace RadGridAndDomainDataSource
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
    using Microsoft.ServiceModel.DomainServices.LinqToSql;


    // TODO: Create methods containing your application logic.
    [EnableClientAccess()]
    public class NorthwindDomainService : LinqToSqlDomainService<NorthwindDataClassesDataContext>
    {

        // TODO: Consider
        // 1. Adding parameters to this method and constraining returned results, and/or
        // 2. Adding query methods taking different parameters.
        public IQueryable<Customer> GetCustomers()
        {
            return this.DataContext.Customers;
        }

        public void InsertCustomer(Customer customer)
        {
            this.DataContext.Customers.InsertOnSubmit(customer);
        }

        public void UpdateCustomer(Customer currentCustomer)
        {
            this.DataContext.Customers.Attach(currentCustomer, this.ChangeSet.GetOriginal(currentCustomer));
        }

        public void DeleteCustomer(Customer customer)
        {
            this.DataContext.Customers.Attach(customer);
            this.DataContext.Customers.DeleteOnSubmit(customer);
        }

        // TODO: Consider
        // 1. Adding parameters to this method and constraining returned results, and/or
        // 2. Adding query methods taking different parameters.
        public IQueryable<Order> GetOrders()
        {
            return this.DataContext.Orders;
        }

        public IQueryable<Order> GetOrdersByCustomerID(string CustomerID)
        {
            return this.DataContext.Orders.Where<Order>( order=> order.CustomerID == CustomerID);
        }

        public void InsertOrder(Order order)
        {
            this.DataContext.Orders.InsertOnSubmit(order);
        }

        public void UpdateOrder(Order currentOrder)
        {
            this.DataContext.Orders.Attach(currentOrder, this.ChangeSet.GetOriginal(currentOrder));
        }

        public void DeleteOrder(Order order)
        {
            this.DataContext.Orders.Attach(order);
            this.DataContext.Orders.DeleteOnSubmit(order);
        }
    }
}


